searchData={"items":[{"type":"module","title":"GeoMeasure","doc":"Calculates properties of Geo structs.","ref":"GeoMeasure.html"},{"type":"function","title":"GeoMeasure.area/1","doc":"","ref":"GeoMeasure.html#area/1"},{"type":"function","title":"GeoMeasure.bbox/1","doc":"","ref":"GeoMeasure.html#bbox/1"},{"type":"function","title":"GeoMeasure.centroid/1","doc":"","ref":"GeoMeasure.html#centroid/1"},{"type":"function","title":"GeoMeasure.distance/2","doc":"","ref":"GeoMeasure.html#distance/2"},{"type":"function","title":"GeoMeasure.extent/1","doc":"","ref":"GeoMeasure.html#extent/1"},{"type":"function","title":"GeoMeasure.perimeter/1","doc":"","ref":"GeoMeasure.html#perimeter/1"},{"type":"module","title":"GeoMeasure.Area","doc":"Calculates the area of Geo struct.","ref":"GeoMeasure.Area.html"},{"type":"module","title":"Examples: - GeoMeasure.Area","doc":"iex> GeoMeasure.Area.area(%Geo.Point{coordinates: {1, 2}})\n    nil\n\n    iex> GeoMeasure.Area.area(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n    nil\n\n    iex> GeoMeasure.Area.area(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n    4.0","ref":"GeoMeasure.Area.html#module-examples"},{"type":"function","title":"GeoMeasure.Area.area/1","doc":"Calculates the area of a Geo struct.","ref":"GeoMeasure.Area.html#area/1"},{"type":"module","title":"GeoMeasure.Bbox","doc":"Calculates the bounding box of a Geo struct.\n\nExamples:\n\n    iex> GeoMeasure.Bbox.bbox(%Geo.Point{coordinates: {1, 2}})\n    %Geo.Point{coordinates: {1, 2}}\n\n    iex> GeoMeasure.Bbox.bbox(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n    %Geo.Polygon{coordinates: [[{1, 2}, {1, 4}, {3, 4}, {3, 2}, {1, 2}]]}\n\n    iex> GeoMeasure.Bbox.bbox(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n    %Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]}","ref":"GeoMeasure.Bbox.html"},{"type":"function","title":"GeoMeasure.Bbox.bbox/1","doc":"Calculates the bounding box of a Geo struct as a Geo.Polygon.","ref":"GeoMeasure.Bbox.html#bbox/1"},{"type":"module","title":"GeoMeasure.Centroid","doc":"Calculates the centroid of a Geo struct.","ref":"GeoMeasure.Centroid.html"},{"type":"module","title":"Examples: - GeoMeasure.Centroid","doc":"iex> GeoMeasure.Centroid.centroid(%Geo.Point{coordinates: {1, 2}})\n    %Geo.Point{coordinates: {1, 2}}\n\n    iex> GeoMeasure.Centroid.centroid(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n    %Geo.Point{coordinates: {2.0, 3.0}}\n\n    iex> GeoMeasure.Centroid.centroid(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n    %Geo.Point{coordinates: {1.0, 1.0}}","ref":"GeoMeasure.Centroid.html#module-examples"},{"type":"function","title":"GeoMeasure.Centroid.centroid/1","doc":"Calculates the centroid of a Geo struct as a Geo.Point.","ref":"GeoMeasure.Centroid.html#centroid/1"},{"type":"module","title":"GeoMeasure.Distance","doc":"Calculates distance between two coordinate pairs or Geo.Point structs.","ref":"GeoMeasure.Distance.html"},{"type":"module","title":"Examples: - GeoMeasure.Distance","doc":"iex> GeoMeasure.Distance.distance({0, 0}, {5, 0})\n    5.0\n\n    iex> GeoMeasure.Distance.distance({0, 0}, {3, 4})\n    5.0\n\n    iex> GeoMeasure.Distance.distance(%Geo.Point{coordinates: {0, 0}}, %Geo.Point{coordinates: {3, 4}})\n    5.0","ref":"GeoMeasure.Distance.html#module-examples"},{"type":"function","title":"GeoMeasure.Distance.distance/2","doc":"Calculates the distance between two coordinate pairs or Geo.Point structs.","ref":"GeoMeasure.Distance.html#distance/2"},{"type":"module","title":"GeoMeasure.Extent","doc":"Calculates the extent of a Geo struct.","ref":"GeoMeasure.Extent.html"},{"type":"module","title":"Examples: - GeoMeasure.Extent","doc":"iex> GeoMeasure.Extent.extent(%Geo.Point{coordinates: {1, 2}})\n    nil\n\n    iex> GeoMeasure.Extent.extent(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n    {1, 3, 2, 4}\n\n    iex> GeoMeasure.Extent.extent(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n    {0, 2, 0, 2}","ref":"GeoMeasure.Extent.html#module-examples"},{"type":"function","title":"GeoMeasure.Extent.calculate_extent/1","doc":"","ref":"GeoMeasure.Extent.html#calculate_extent/1"},{"type":"function","title":"GeoMeasure.Extent.extent/1","doc":"Calculates the extent coordinates of a Geo struct.","ref":"GeoMeasure.Extent.html#extent/1"},{"type":"module","title":"GeoMeasure.Perimeter","doc":"Calculates the perimeter of a Geo struct.","ref":"GeoMeasure.Perimeter.html"},{"type":"module","title":"Examples: - GeoMeasure.Perimeter","doc":"iex> GeoMeasure.Perimeter.perimeter(%Geo.Point{coordinates: {1, 2}})\n    nil\n\n    iex> GeoMeasure.Perimeter.perimeter(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n    nil\n\n    iex> GeoMeasure.Perimeter.perimeter(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n    8.0","ref":"GeoMeasure.Perimeter.html#module-examples"},{"type":"function","title":"GeoMeasure.Perimeter.perimeter/1","doc":"Calculates the perimeter of a Geo struct.","ref":"GeoMeasure.Perimeter.html#perimeter/1"},{"type":"extras","title":"GeoMeasure","doc":"# GeoMeasure\n\nA collection of functions calculating different properties of [Geo](https://github.com/felt/geo/tree/master) structs.\n\nCurrently, this project supports only the following geometries:\n\n- Point\n- LineString\n- Polygon\n\nCurrently, the following properties can be calculated for the supported [Geo](https://github.com/felt/geo/tree/master) structs:\n\n- Area\n- Bounding box\n- Centroid\n- Distance (between two coordinate pairs or Geo.Point structs)\n- Extent\n- Perimeter\n\n_Note_: If you would like to make in-memory calculations to determine the relationship between two Geo structs, please check out [topo](https://github.com/pkinney/topo).\n\n```elixir\ndefp deps do\n  [\n    {:geomeasure, \"~> 0.0.1\"}\n  ]\nend\n```","ref":"readme.html"},{"type":"extras","title":"Examples - GeoMeasure","doc":"Each function can be called through their module, such as `GeoMeasure.Area.area` or `GeoMeasure.Perimeter.perimeter`. Alternatively, as a convenience, delegates have been implemented from the main `GeoMeasure` module, enabling shortened calls, such as `GeoMeasure.area` or `GeoMeasure.perimeter`.","ref":"readme.html#examples"},{"type":"extras","title":"Area - GeoMeasure","doc":"Calling through the `GeoMeasure.Area` module:\n\n```elixir\niex(1)> GeoMeasure.Area.area(%Geo.Point{coordinates: {1, 2}})\nnil\n\niex(2)> GeoMeasure.Area.area(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\nnil\n\niex(3)> GeoMeasure.Area.area(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n4.0\n```\n\nCalling through the `GeoMeasure` module:\n\n```elixir\niex(1)> GeoMeasure.area(%Geo.Point{coordinates: {1, 2}})\nnil\n\niex(2)> GeoMeasure.area(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\nnil\n\niex(3)> GeoMeasure.area(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n4.0\n```","ref":"readme.html#area"},{"type":"extras","title":"Bounding Box - GeoMeasure","doc":"Calling through the `GeoMeasure.Bbox` module:\n\n```elixir\niex(1)> GeoMeasure.Bbox.bbox(%Geo.Point{coordinates: {1, 2}})\n%Geo.Point{coordinates: {1, 2}, srid: nil, properties: %{}}\n\niex(2)> GeoMeasure.Bbox.bbox(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n%Geo.Polygon{\n  coordinates: [[{1, 2}, {1, 4}, {3, 4}, {3, 2}, {1, 2}]],\n  srid: nil,\n  properties: %{}\n}\n\niex(3)> GeoMeasure.Bbox.bbox(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n%Geo.Polygon{\n  coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]],\n  srid: nil,\n  properties: %{}\n}\n```\n\nCalling through the `GeoMeasure` module:\n\n```elixir\niex(1)> GeoMeasure.bbox(%Geo.Point{coordinates: {1, 2}})\n%Geo.Point{coordinates: {1, 2}, srid: nil, properties: %{}}\n\niex(2)> GeoMeasure.bbox(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n%Geo.Polygon{\n  coordinates: [[{1, 2}, {1, 4}, {3, 4}, {3, 2}, {1, 2}]],\n  srid: nil,\n  properties: %{}\n}\n\niex(3)> GeoMeasure.bbox(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n%Geo.Polygon{\n  coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]],\n  srid: nil,\n  properties: %{}\n}\n```","ref":"readme.html#bounding-box"},{"type":"extras","title":"Centroid - GeoMeasure","doc":"Calling through the `GeoMeasure.Centroid` module:\n\n```elixir\niex(1)> GeoMeasure.Centroid.centroid(%Geo.Point{coordinates: {1, 2}})\n%Geo.Point{coordinates: {1, 2}, srid: nil, properties: %{}}\n\niex(2)> GeoMeasure.Centroid.centroid(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n%Geo.Point{coordinates: {2.0, 3.0}, srid: nil, properties: %{}}\n\niex(3)> GeoMeasure.Centroid.centroid(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n%Geo.Point{coordinates: {1.0, 1.0}, srid: nil, properties: %{}}\n```\n\nCalling through the `GeoMeasure` module:\n\n```elixir\niex(1)> GeoMeasure.centroid(%Geo.Point{coordinates: {1, 2}})\n%Geo.Point{coordinates: {1, 2}, srid: nil, properties: %{}}\n\niex(2)> GeoMeasure.centroid(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n%Geo.Point{coordinates: {2.0, 3.0}, srid: nil, properties: %{}}\n\niex(3)> GeoMeasure.centroid(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n%Geo.Point{coordinates: {1.0, 1.0}, srid: nil, properties: %{}}\n```","ref":"readme.html#centroid"},{"type":"extras","title":"Distance - GeoMeasure","doc":"Calling through the `GeoMeasure.Distance` module:\n\n```elixir\niex(1)> GeoMeasure.Distance.distance({0, 0}, {5, 0})\n5.0\n\niex(2)> GeoMeasure.Distance.distance({0, 0}, {3, 4})\n5.0\n\niex(3)> GeoMeasure.Distance.distance(%Geo.Point{coordinates: {0, 0}}, %Geo.Point{coordinates: {3, 4}})\n5.0\n```\n\nCalling through the `GeoMeasure` module:\n\n```elixir\niex(1)> GeoMeasure.distance({0, 0}, {5, 0})\n5.0\n\niex(2)> GeoMeasure.distance({0, 0}, {3, 4})\n5.0\n\niex(3)> GeoMeasure.distance(%Geo.Point{coordinates: {0, 0}}, %Geo.Point{coordinates: {3, 4}})\n5.0\n```","ref":"readme.html#distance"},{"type":"extras","title":"Extent - GeoMeasure","doc":"Calling through the `GeoMeasure.Extent` module:\n\n```elixir\niex(1)> GeoMeasure.Extent.extent(%Geo.Point{coordinates: {1, 2}})\nnil\n\niex(2)> GeoMeasure.Extent.extent(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n{1, 3, 2, 4}\n\niex(3)> GeoMeasure.Extent.extent(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n{0, 2, 0, 2}\n```\n\nCalling through the `GeoMeasure` module:\n\n```elixir\niex(1)> GeoMeasure.extent(%Geo.Point{coordinates: {1, 2}})\nnil\n\niex(2)> GeoMeasure.extent(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\n{1, 3, 2, 4}\n\niex(3)> GeoMeasure.extent(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n{0, 2, 0, 2}\n```","ref":"readme.html#extent"},{"type":"extras","title":"Perimeter - GeoMeasure","doc":"Calling through the `GeoMeasure.Perimeter` module:\n\n```elixir\niex(1)> GeoMeasure.Perimeter.perimeter(%Geo.Point{coordinates: {1, 2}})\nnil\n\niex(2)> GeoMeasure.Perimeter.perimeter(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\nnil\n\niex(3)> GeoMeasure.Perimeter.perimeter(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n8.0\n```\n\nCalling through the `GeoMeasure` module:\n\n```elixir\niex(1)> GeoMeasure.perimeter(%Geo.Point{coordinates: {1, 2}})\nnil\n\niex(2)> GeoMeasure.perimeter(%Geo.LineString{coordinates: [{1, 2}, {3, 4}]})\nnil\n\niex(3)> GeoMeasure.perimeter(%Geo.Polygon{coordinates: [[{0, 0}, {0, 2}, {2, 2}, {2, 0}, {0, 0}]]})\n8.0\n```","ref":"readme.html#perimeter"},{"type":"extras","title":"Copyright and License - GeoMeasure","doc":"Copyright (c) 2024 simagyari\n\nReleased under the MIT License, which can be found in the repository's [LICENSE](https://github.com/simagyari/geomeasure/blob/main/LICENSE) file.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2024 simagyari\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}